/**
   This program "produces" sequential numbers to stdout.
   The rate of production is set by a command-line argument.

   Pipe the output from this program into the input of Consumer.java.

   Make the producer twice as fast as the consumer, so
   the producer will keep the buffer between them full.
   > java Producer 100 | java Consumer 200
   > java Producer 10  | java Consumer 20
   > java Producer 1   | java Consumer 2
*/

public class Producer
{
   public static void main(String[] args)
   {
      int milliSeconds = 500;
      int count = Integer.MAX_VALUE;
      int counter = 0;
      if (args.length > 0)
      {
         milliSeconds = Integer.parseInt(args[0]);
      }
      if (args.length > 1)
      {
         count = Integer.parseInt(args[1]);
      }
      try
      {
         while(count >= 0)
         {
            System.out.print(counter + " ");
            System.err.println(counter);
            ++counter;
            --count;
            Thread.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
